// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from metro_benchmark_msgs:msg/ComputeTime.idl
// generated code does not contain a copyright notice

#ifndef METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__FUNCTIONS_H_
#define METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "metro_benchmark_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "metro_benchmark_msgs/msg/detail/compute_time__struct.h"

/// Initialize msg/ComputeTime message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * metro_benchmark_msgs__msg__ComputeTime
 * )) before or use
 * metro_benchmark_msgs__msg__ComputeTime__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
bool
metro_benchmark_msgs__msg__ComputeTime__init(metro_benchmark_msgs__msg__ComputeTime * msg);

/// Finalize msg/ComputeTime message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
void
metro_benchmark_msgs__msg__ComputeTime__fini(metro_benchmark_msgs__msg__ComputeTime * msg);

/// Create msg/ComputeTime message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * metro_benchmark_msgs__msg__ComputeTime__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
metro_benchmark_msgs__msg__ComputeTime *
metro_benchmark_msgs__msg__ComputeTime__create();

/// Destroy msg/ComputeTime message.
/**
 * It calls
 * metro_benchmark_msgs__msg__ComputeTime__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
void
metro_benchmark_msgs__msg__ComputeTime__destroy(metro_benchmark_msgs__msg__ComputeTime * msg);

/// Check for msg/ComputeTime message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
bool
metro_benchmark_msgs__msg__ComputeTime__are_equal(const metro_benchmark_msgs__msg__ComputeTime * lhs, const metro_benchmark_msgs__msg__ComputeTime * rhs);

/// Copy a msg/ComputeTime message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
bool
metro_benchmark_msgs__msg__ComputeTime__copy(
  const metro_benchmark_msgs__msg__ComputeTime * input,
  metro_benchmark_msgs__msg__ComputeTime * output);

/// Initialize array of msg/ComputeTime messages.
/**
 * It allocates the memory for the number of elements and calls
 * metro_benchmark_msgs__msg__ComputeTime__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
bool
metro_benchmark_msgs__msg__ComputeTime__Sequence__init(metro_benchmark_msgs__msg__ComputeTime__Sequence * array, size_t size);

/// Finalize array of msg/ComputeTime messages.
/**
 * It calls
 * metro_benchmark_msgs__msg__ComputeTime__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
void
metro_benchmark_msgs__msg__ComputeTime__Sequence__fini(metro_benchmark_msgs__msg__ComputeTime__Sequence * array);

/// Create array of msg/ComputeTime messages.
/**
 * It allocates the memory for the array and calls
 * metro_benchmark_msgs__msg__ComputeTime__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
metro_benchmark_msgs__msg__ComputeTime__Sequence *
metro_benchmark_msgs__msg__ComputeTime__Sequence__create(size_t size);

/// Destroy array of msg/ComputeTime messages.
/**
 * It calls
 * metro_benchmark_msgs__msg__ComputeTime__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
void
metro_benchmark_msgs__msg__ComputeTime__Sequence__destroy(metro_benchmark_msgs__msg__ComputeTime__Sequence * array);

/// Check for msg/ComputeTime message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
bool
metro_benchmark_msgs__msg__ComputeTime__Sequence__are_equal(const metro_benchmark_msgs__msg__ComputeTime__Sequence * lhs, const metro_benchmark_msgs__msg__ComputeTime__Sequence * rhs);

/// Copy an array of msg/ComputeTime messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_metro_benchmark_msgs
bool
metro_benchmark_msgs__msg__ComputeTime__Sequence__copy(
  const metro_benchmark_msgs__msg__ComputeTime__Sequence * input,
  metro_benchmark_msgs__msg__ComputeTime__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__FUNCTIONS_H_
