// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from metro_benchmark_msgs:msg/ComputeTime.idl
// generated code does not contain a copyright notice

#ifndef METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__STRUCT_HPP_
#define METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'duration'
#include "builtin_interfaces/msg/detail/duration__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__metro_benchmark_msgs__msg__ComputeTime __attribute__((deprecated))
#else
# define DEPRECATED__metro_benchmark_msgs__msg__ComputeTime __declspec(deprecated)
#endif

namespace metro_benchmark_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ComputeTime_
{
  using Type = ComputeTime_<ContainerAllocator>;

  explicit ComputeTime_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    duration(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
      this->parent_id = "";
    }
  }

  explicit ComputeTime_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    duration(_alloc, _init),
    id(_alloc),
    parent_id(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
      this->parent_id = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _duration_type =
    builtin_interfaces::msg::Duration_<ContainerAllocator>;
  _duration_type duration;
  using _id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _id_type id;
  using _parent_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _parent_id_type parent_id;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__duration(
    const builtin_interfaces::msg::Duration_<ContainerAllocator> & _arg)
  {
    this->duration = _arg;
    return *this;
  }
  Type & set__id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__parent_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->parent_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator> *;
  using ConstRawPtr =
    const metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__metro_benchmark_msgs__msg__ComputeTime
    std::shared_ptr<metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__metro_benchmark_msgs__msg__ComputeTime
    std::shared_ptr<metro_benchmark_msgs::msg::ComputeTime_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ComputeTime_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->duration != other.duration) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->parent_id != other.parent_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const ComputeTime_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ComputeTime_

// alias to use template instance with default allocator
using ComputeTime =
  metro_benchmark_msgs::msg::ComputeTime_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace metro_benchmark_msgs

#endif  // METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__STRUCT_HPP_
